<template>
  <div>
    <slot>Select an option</slot>
    <div class="input-group m-1">
      <input
        aria-label="Search for keywords"
        type="text"
        :placeholder="$t('searchfilter.search_keyword')"
        maxlength="100"
        v-model="filter_word"
        class="form-control">
      <button
        aria-label="Reset keyword search"
        class="btn btn-outline-secondary"
        type="button"
        @click="resetSearch"
        id="button-addon2">✗</button>
    </div>
    <ul ref="inputs" class="scrollable">
      <li v-for="(option, index) in options" :key="index" v-show="searchMatch(option)">
        <div class="form-check ms-1">
          <input
            class="form-check-input"
            type="checkbox"
            :value="option"
            :id="toId(option+index)"
            @change="changed">
          <label class="form-check-label" :for="toId(option+index)">
            {{ option }}
          </label>
        </div>
      </li>
    </ul>
  </div>
</template>

<script>
import helper from '../../helper'

export default {
  name: 'MultipleSelectionFilter',
  mixins: [helper],
  mounted () {
    // restore selection when mounted (e.g. when going back)
    this.set_input_selection(this.current)
  },
  data () {
    return {
      filter_word: ''
    }
  },
  computed: {
    options () {
      return [...new Set(this.$store.state.journals.map((e) => e.keywords).flat())].sort()
    },
    current: {
      // the current value in vuex store
      set (v) {
        this.$store.commit('SET_FILTER_KEYWORDS', v)
      },
      get () {
        return this.$store.state.filters.keywords
      }
    }
  },
  methods: {
    changed () {
      this.current = this.get_input_selection()
    },
    get_input_selection () {
      return this.get_inputs().filter((e) => e.checked).map((e) => e.value)
    },
    set_input_selection (values) {
      for (const input of this.get_inputs()) {
        input.checked = values.includes(input.value)
      }
    },
    get_inputs () {
      return [...this.$refs.inputs.getElementsByTagName('input')]
    },
    searchMatch (option) {
      return option.toLowerCase().includes(this.filter_word.toLowerCase())
    },
    resetSearch () {
      this.filter_word = ''
    }
  },
  watch: {
    current (newValue) {
      // update when store is changed
      this.set_input_selection(newValue)
    }
  }
}
</script>

<style scoped>
ul {
  max-height: 300px;
  list-style-type: none;
  padding-left: 0;
}
.scrollable {
  overflow-y: scroll;
}
</style>
